package org.springblade.person.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.person.entity.Veterans;
import org.springblade.person.vo.VeteransVO;
import org.springblade.person.wrapper.VeteransWrapper;
import org.springblade.person.service.IVeteransService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-28
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/veterans")

public class VeteransClient implements IVeteransClient {

    private final IVeteransService veteransService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public VeteransVO detail(@SpringQueryMap Veterans veterans) {
        Veterans detail = veteransService.getOne(Condition.getQueryWrapper(veterans));
        return VeteransWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<VeteransVO> list(Veterans veterans) {
        return VeteransWrapper.build().listVO(veteransService.list(Condition.getQueryWrapper(veterans)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Veterans veterans) {
        return veteransService.save(veterans);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Veterans veterans) {
        return veteransService.updateById(veterans);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Veterans veterans) {
        return veteransService.saveOrUpdate(veterans);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return veteransService.deleteLogic(Func.toLongList(ids));
        }


}
